diff --git a/rsvg-cairo-draw.h b/rsvg-cairo-draw.h
index 7d354aa..01556b7 100644
--- a/rsvg-cairo-draw.h
+++ b/rsvg-cairo-draw.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-shapes.c: Draw shapes with libart
 
@@ -31,23 +32,27 @@
 
 G_BEGIN_DECLS 
 
-PangoContext	*rsvg_cairo_create_pango_context    (RsvgDrawingCtx *ctx);
-void		 rsvg_cairo_render_pango_layout	    (RsvgDrawingCtx *ctx, PangoLayout *layout, 
-						     double x, double y);
-void		 rsvg_cairo_render_path		    (RsvgDrawingCtx *ctx, 
-						     const RsvgBpathDef * path);
-void		 rsvg_cairo_render_image	    (RsvgDrawingCtx *ctx, const GdkPixbuf * img, 
-						     double x, double y, double w, double h);
-void		 rsvg_cairo_push_discrete_layer	    (RsvgDrawingCtx *ctx);
-void		 rsvg_cairo_pop_discrete_layer	    (RsvgDrawingCtx *ctx);
-void		 rsvg_cairo_add_clipping_rect	    (RsvgDrawingCtx *ctx,
-						     double x, double y, double width, double height);
-
-GdkPixbuf	*rsvg_cairo_get_image_of_node	    (RsvgDrawingCtx *ctx, RsvgNode *drawable, 
-						     double width, double height);
-
-void		 rsvg_cairo_to_pixbuf		    (guint8 * pixels, int rowstride, int height);
-void		 rsvg_pixbuf_to_cairo		    (guint8 * pixels, int rowstride, int height);
+G_GNUC_INTERNAL
+PangoContext    *rsvg_cairo_create_pango_context    (RsvgDrawingCtx *ctx);
+G_GNUC_INTERNAL
+void         rsvg_cairo_render_pango_layout	    (RsvgDrawingCtx *ctx, PangoLayout *layout, 
+                                                 double x, double y);
+G_GNUC_INTERNAL
+void         rsvg_cairo_render_path             (RsvgDrawingCtx *ctx, 
+                                                 const cairo_path_t *path);
+G_GNUC_INTERNAL
+void         rsvg_cairo_render_surface          (RsvgDrawingCtx *ctx, cairo_surface_t *surface,
+                                                 double x, double y, double w, double h);
+G_GNUC_INTERNAL
+void         rsvg_cairo_push_discrete_layer	    (RsvgDrawingCtx *ctx);
+G_GNUC_INTERNAL
+void         rsvg_cairo_pop_discrete_layer      (RsvgDrawingCtx *ctx);
+G_GNUC_INTERNAL
+void         rsvg_cairo_add_clipping_rect       (RsvgDrawingCtx *ctx,
+                                                 double x, double y, double width, double height);
+G_GNUC_INTERNAL
+cairo_surface_t*rsvg_cairo_get_surface_of_node  (RsvgDrawingCtx *ctx, RsvgNode *drawable, 
+                                                 double width, double height);
 
 G_END_DECLS
 
diff --git a/rsvg-cairo-render.c b/rsvg-cairo-render.c
index b7f2c8e..4285fe8 100644
--- a/rsvg-cairo-render.c
+++ b/rsvg-cairo-render.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-cairo-render.c: The cairo backend plugin
 
@@ -31,6 +32,7 @@
 #include <string.h>
 
 #include "rsvg.h"
+#include "rsvg-private.h"
 #include "rsvg-cairo.h"
 #include "rsvg-cairo-draw.h"
 #include "rsvg-cairo-render.h"
@@ -40,7 +42,7 @@
 static void
 rsvg_cairo_render_free (RsvgRender * self)
 {
-    RsvgCairoRender *me = (RsvgCairoRender *) self;
+    RsvgCairoRender *me = RSVG_CAIRO_RENDER (self);
 
     /* TODO */
 
@@ -52,15 +54,16 @@ rsvg_cairo_render_new (cairo_t * cr, double width, double height)
 {
     RsvgCairoRender *cairo_render = g_new0 (RsvgCairoRender, 1);
 
+    cairo_render->super.type = RSVG_RENDER_TYPE_CAIRO;
     cairo_render->super.free = rsvg_cairo_render_free;
     cairo_render->super.create_pango_context = rsvg_cairo_create_pango_context;
     cairo_render->super.render_pango_layout = rsvg_cairo_render_pango_layout;
-    cairo_render->super.render_image = rsvg_cairo_render_image;
+    cairo_render->super.render_surface = rsvg_cairo_render_surface;
     cairo_render->super.render_path = rsvg_cairo_render_path;
     cairo_render->super.pop_discrete_layer = rsvg_cairo_pop_discrete_layer;
     cairo_render->super.push_discrete_layer = rsvg_cairo_push_discrete_layer;
     cairo_render->super.add_clipping_rect = rsvg_cairo_add_clipping_rect;
-    cairo_render->super.get_image_of_node = rsvg_cairo_get_image_of_node;
+    cairo_render->super.get_surface_of_node = rsvg_cairo_get_surface_of_node;
     cairo_render->width = width;
     cairo_render->height = height;
     cairo_render->offset_x = 0;
@@ -69,7 +72,7 @@ rsvg_cairo_render_new (cairo_t * cr, double width, double height)
     cairo_render->cr = cr;
     cairo_render->cr_stack = NULL;
     cairo_render->bb_stack = NULL;
-    cairo_render->pixbuf_stack = NULL;
+    cairo_render->surfaces_stack = NULL;
 
     return cairo_render;
 }
@@ -114,8 +117,8 @@ rsvg_cairo_new_drawing_ctx (cairo_t * cr, RsvgHandle * handle)
     RsvgDrawingCtx *draw;
     RsvgCairoRender *render;
     RsvgState *state;
-    cairo_matrix_t cairo_transform;
-    double affine[6], bbx0, bby0, bbx1, bby1;
+    cairo_matrix_t affine;
+    double bbx0, bby0, bbx1, bby1;
 
     rsvg_handle_get_dimensions (handle, &data);
     if (data.width == 0 || data.height == 0)
@@ -123,12 +126,12 @@ rsvg_cairo_new_drawing_ctx (cairo_t * cr, RsvgHandle * handle)
 
     draw = g_new (RsvgDrawingCtx, 1);
 
-    cairo_get_matrix (cr, &cairo_transform);
+    cairo_get_matrix (cr, &affine);
 
     /* find bounding box of image as transformed by the current cairo context
      * The size of this bounding box determines the size of the intermediate
      * surfaces allocated during drawing. */
-    rsvg_cairo_transformed_image_bounding_box (&cairo_transform,
+    rsvg_cairo_transformed_image_bounding_box (&affine,
                                                data.width, data.height,
                                                &bbx0, &bby0, &bbx1, &bby1);
 
@@ -144,57 +147,47 @@ rsvg_cairo_new_drawing_ctx (cairo_t * cr, RsvgHandle * handle)
     draw->state = NULL;
 
     draw->defs = handle->priv->defs;
-    draw->base_uri = g_strdup (handle->priv->base_uri);
     draw->dpi_x = handle->priv->dpi_x;
     draw->dpi_y = handle->priv->dpi_y;
-    draw->vb.w = data.em;
-    draw->vb.h = data.ex;
+    draw->vb.rect.width = data.em;
+    draw->vb.rect.height = data.ex;
     draw->pango_context = NULL;
     draw->drawsub_stack = NULL;
-    draw->ptrs = NULL;
+    draw->acquired_nodes = NULL;
 
     rsvg_state_push (draw);
-    state = rsvg_state_current (draw);
+    state = rsvg_current_state (draw);
 
     /* apply cairo transformation to our affine transform */
-    affine[0] = cairo_transform.xx;
-    affine[1] = cairo_transform.yx;
-    affine[2] = cairo_transform.xy;
-    affine[3] = cairo_transform.yy;
-    affine[4] = cairo_transform.x0;
-    affine[5] = cairo_transform.y0;
-    _rsvg_affine_multiply (state->affine, affine, state->affine);
+    cairo_matrix_multiply (&state->affine, &affine, &state->affine);
 
     /* scale according to size set by size_func callback */
-    affine[0] = data.width / data.em;
-    affine[1] = 0;
-    affine[2] = 0;
-    affine[3] = data.height / data.ex;
-    affine[4] = 0;
-    affine[5] = 0;
-    _rsvg_affine_multiply (state->affine, affine, state->affine);
+    cairo_matrix_init_scale (&affine, data.width / data.em, data.height / data.ex);
+    cairo_matrix_multiply (&state->affine, &affine, &state->affine);
 
     /* adjust transform so that the corner of the bounding box above is
      * at (0,0) - we compensate for this in _set_rsvg_affine() in
      * rsvg-cairo-render.c and a few other places */
-    state->affine[4] -= render->offset_x;
-    state->affine[5] -= render->offset_y;
+    state->affine.x0 -= render->offset_x;
+    state->affine.y0 -= render->offset_y;
 
-    rsvg_bbox_init (&((RsvgCairoRender *) draw->render)->bbox, state->affine);
+    rsvg_bbox_init (&((RsvgCairoRender *) draw->render)->bbox, &state->affine);
 
     return draw;
 }
 
 /**
- * rsvg_handle_render_cairo_sub
- * @handle: A RsvgHandle
+ * rsvg_handle_render_cairo_sub:
+ * @handle: A #RsvgHandle
  * @cr: A Cairo renderer
- * @id: An element's id within the SVG, or %NULL to render the whole SVG. For
- * example, if you have a layer called "layer1" that you wish to render, pass 
- * "##layer1" as the id.
+ * @id: (nullable): An element's id within the SVG, or %NULL to render
+ *   the whole SVG. For example, if you have a layer called "layer1"
+ *   that you wish to render, pass "##layer1" as the id.
  *
  * Draws a subset of a SVG to a Cairo surface
  *
+ * Returns: %TRUE if drawing succeeded.
+ *
  * Since: 2.14
  */
 gboolean
@@ -211,10 +204,10 @@ rsvg_handle_render_cairo_sub (RsvgHandle * handle, cairo_t * cr, const char *id)
     if (id && *id)
         drawsub = rsvg_defs_lookup (handle->priv->defs, id);
 
-	if (drawsub == NULL && id != NULL) {
-		/* todo: there's no way to signal that @id doesn't exist */
-		return FALSE;
-	}
+    if (drawsub == NULL && id != NULL) {
+        /* todo: there's no way to signal that @id doesn't exist */
+        return FALSE;
+    }
 
     draw = rsvg_cairo_new_drawing_ctx (cr, handle);
     if (!draw)
@@ -234,16 +227,17 @@ rsvg_handle_render_cairo_sub (RsvgHandle * handle, cairo_t * cr, const char *id)
     rsvg_state_pop (draw);
     rsvg_drawing_ctx_free (draw);
 
-	return TRUE;
+    return TRUE;
 }
 
 /**
- * rsvg_handle_render_cairo
- * @handle: A RsvgHandle
+ * rsvg_handle_render_cairo:
+ * @handle: A #RsvgHandle
  * @cr: A Cairo renderer
  *
  * Draws a SVG to a Cairo surface
  *
+ * Returns: %TRUE if drawing succeeded.
  * Since: 2.14
  */
 gboolean
diff --git a/rsvg-cairo-render.h b/rsvg-cairo-render.h
index e49fca2..d9bfd57 100644
--- a/rsvg-cairo-render.h
+++ b/rsvg-cairo-render.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-cairo-render.h: The cairo backend plugin
 
@@ -46,12 +47,17 @@ struct _RsvgCairoRender {
 
     RsvgBbox bbox;
     GList *bb_stack;
-    GList *pixbuf_stack;
+    GList *surfaces_stack;
 };
 
+#define RSVG_CAIRO_RENDER(render) (_RSVG_RENDER_CIC ((render), RSVG_RENDER_TYPE_CAIRO, RsvgCairoRender))
+
+G_GNUC_INTERNAL
 RsvgCairoRender *rsvg_cairo_render_new		(cairo_t * cr, double width, double height);
-void		 rsvg_cairo_render_rsvg_handle	(cairo_t * cr, RsvgHandle * handle);
-RsvgDrawingCtx *rsvg_cairo_new_drawing_ctx (cairo_t * cr, RsvgHandle * handle);
+G_GNUC_INTERNAL
+void		rsvg_cairo_render_rsvg_handle	(cairo_t * cr, RsvgHandle * handle);
+G_GNUC_INTERNAL
+RsvgDrawingCtx *rsvg_cairo_new_drawing_ctx	(cairo_t * cr, RsvgHandle * handle);
 
 G_END_DECLS
 
diff --git a/rsvg-cairo.h b/rsvg-cairo.h
index 4aa8c4b..d9ebfb2 100644
--- a/rsvg-cairo.h
+++ b/rsvg-cairo.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /* 
    rsvg-cairo.h: SAX-based renderer for SVG files using cairo
  
@@ -22,6 +23,10 @@
    Author: Carl Worth <cworth@cworth.org>
 */
 
+#if !defined (__RSVG_RSVG_H_INSIDE__) && !defined (RSVG_COMPILATION)
+#warning "Including <librsvg/rsvg-cairo.h> directly is deprecated."
+#endif
+
 #ifndef RSVG_CAIRO_H
 #define RSVG_CAIRO_H
 
@@ -29,8 +34,8 @@
 
 G_BEGIN_DECLS 
 
-gboolean	rsvg_handle_render_cairo     (RsvgHandle * handle, cairo_t * cr);
-gboolean	rsvg_handle_render_cairo_sub (RsvgHandle * handle, cairo_t * cr, const char *id);
+gboolean    rsvg_handle_render_cairo     (RsvgHandle * handle, cairo_t * cr);
+gboolean    rsvg_handle_render_cairo_sub (RsvgHandle * handle, cairo_t * cr, const char *id);
 
 G_END_DECLS
 
diff --git a/rsvg-compat.h b/rsvg-compat.h
new file mode 100644
index 0000000..897e4c2
--- /dev/null
+++ b/rsvg-compat.h
@@ -0,0 +1,13 @@
+/* rsvg-compat.h: miscellaneous compatibility functions to deal with deprecations in the platform */
+
+#ifndef RSVG_COMPAT_H
+#define RSVG_COMPAT_H
+
+/* g_type_init() was deprecated in glib 2.36.0 */
+#if !GLIB_CHECK_VERSION (2, 36, 0)
+#  define RSVG_G_TYPE_INIT g_type_init ()
+#else
+#  define RSVG_G_TYPE_INIT {}
+#endif
+
+#endif /* RSVG_COMPAT_H */
diff --git a/rsvg-cond.c b/rsvg-cond.c
index 1b3655f..b5c02a4 100644
--- a/rsvg-cond.c
+++ b/rsvg-cond.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-cond.c: Handle SVG conditionals
 
diff --git a/rsvg-convert.c b/rsvg-convert.c
index 115d825..468e824 100644
--- a/rsvg-convert.c
+++ b/rsvg-convert.c
@@ -1,4 +1,6 @@
-/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
+/*
 
    rsvg-convert.c: Command line utility for exercising rsvg with cairo.
  
@@ -32,11 +34,25 @@
 #include <stdlib.h>
 #include <string.h>
 #include <locale.h>
+#include <unistd.h>
+#include <glib/gi18n.h>
+#include <gio/gio.h>
+
+#ifdef G_OS_UNIX
+#include <gio/gunixinputstream.h>
+#endif
+
+#ifdef G_OS_WIN32
+#define WIN32_LEAN_AND_MEAN
+#include <windows.h>
+
+#include <gio/gwin32inputstream.h>
+#endif
 
 #include "rsvg-css.h"
 #include "rsvg.h"
-#include "rsvg-cairo.h"
-#include "rsvg-private.h"
+#include "rsvg-compat.h"
+#include "rsvg-size-callback.h"
 
 #ifdef CAIRO_HAS_PS_SURFACE
 #include <cairo-ps.h>
@@ -50,69 +66,47 @@
 #include <cairo-svg.h>
 #endif
 
+#ifdef CAIRO_HAS_XML_SURFACE
+#include <cairo-xml.h>
+#endif
+
 static void
 display_error (GError * err)
 {
     if (err) {
-        g_print ("%s\n", err->message);
+        g_printerr ("%s\n", err->message);
         g_error_free (err);
     }
 }
 
-static RsvgHandle *
-rsvg_handle_new_from_stdio_file (FILE * f, GError ** error)
-{
-    RsvgHandle *handle;
-    gchar *current_dir;
-    gchar *base_uri;
-
-    handle = rsvg_handle_new ();
-
-    while (!feof (f)) {
-        guchar buffer[4096];
-        gsize length = fread (buffer, 1, sizeof (buffer), f);
-
-        if (length > 0) {
-            if (!rsvg_handle_write (handle, buffer, length, error)) {
-                g_object_unref (G_OBJECT (handle));
-                return NULL;
-            }
-        } else if (ferror (f)) {
-            g_object_unref (G_OBJECT (handle));
-            return NULL;
-        }
-    }
-
-    if (!rsvg_handle_close (handle, error)) {
-        g_object_unref (G_OBJECT (handle));
-        return NULL;
-    }
-
-    current_dir = g_get_current_dir ();
-    base_uri = g_build_filename (current_dir, "file.svg", NULL);
-    rsvg_handle_set_base_uri (handle, base_uri);
-    g_free (base_uri);
-    g_free (current_dir);
-
-    return handle;
-}
-
-static void
-rsvg_cairo_size_callback (int *width, int *height, gpointer data)
-{
-    RsvgDimensionData *dimensions = data;
-    *width = dimensions->width;
-    *height = dimensions->height;
-}
-
 static cairo_status_t
 rsvg_cairo_write_func (void *closure, const unsigned char *data, unsigned int length)
 {
     if (fwrite (data, 1, length, (FILE *) closure) == length)
-		return CAIRO_STATUS_SUCCESS;
-	return CAIRO_STATUS_WRITE_ERROR;
+        return CAIRO_STATUS_SUCCESS;
+    return CAIRO_STATUS_WRITE_ERROR;
 }
 
+static char *
+get_lookup_id_from_command_line (const char *lookup_id)
+{
+    char *export_lookup_id;
+
+    if (lookup_id == NULL)
+        export_lookup_id = NULL;
+    else {
+        /* rsvg_handle_has_sub() and rsvg_defs_lookup() expect ids to have a
+         * '#' prepended to them, so they can lookup ids in externs like
+         * "subfile.svg#subid".  For the user's convenience, we include this
+         * '#' automatically; we only support specifying ids from the
+         * toplevel, and don't expect users to lookup things in externs.
+         */
+        export_lookup_id = g_strdup_printf ("#%s", lookup_id);
+    }
+
+    return export_lookup_id;
+}
+ 
 int
 main (int argc, char **argv)
 {
@@ -127,21 +121,32 @@ main (int argc, char **argv)
     int bVersion = 0;
     char *format = NULL;
     char *output = NULL;
+    char *export_id = NULL;
     int keep_aspect_ratio = FALSE;
-    guint32 background_color = NULL;
+    guint32 background_color = 0;
     char *background_color_str = NULL;
-    char *base_uri = NULL;
     gboolean using_stdin = FALSE;
+    gboolean unlimited = FALSE;
+    gboolean keep_image_data = FALSE;
+    gboolean no_keep_image_data = FALSE;
     GError *error = NULL;
 
     int i;
     char **args = NULL;
     gint n_args = 0;
-    RsvgHandle *rsvg;
+    RsvgHandle *rsvg = NULL;
     cairo_surface_t *surface = NULL;
     cairo_t *cr = NULL;
+    RsvgHandleFlags flags = RSVG_HANDLE_FLAGS_NONE;
     RsvgDimensionData dimensions;
     FILE *output_file = stdout;
+    char *export_lookup_id;
+    double unscaled_width, unscaled_height;
+    int scaled_width, scaled_height;
+
+#ifdef G_OS_WIN32
+    HANDLE handle;
+#endif
 
     GOptionEntry options_table[] = {
         {"dpi-x", 'd', 0, G_OPTION_ARG_DOUBLE, &dpi_x,
@@ -159,28 +164,33 @@ main (int argc, char **argv)
         {"height", 'h', 0, G_OPTION_ARG_INT, &height,
          N_("height [optional; defaults to the SVG's height]"), N_("<int>")},
         {"format", 'f', 0, G_OPTION_ARG_STRING, &format,
-         N_("save format [optional; defaults to 'png']"), N_("[png, pdf, ps, svg]")},
+         N_("save format [optional; defaults to 'png']"), N_("[png, pdf, ps, eps, svg, xml, recording]")},
         {"output", 'o', 0, G_OPTION_ARG_STRING, &output,
          N_("output filename [optional; defaults to stdout]"), NULL},
+        {"export-id", 'i', 0, G_OPTION_ARG_STRING, &export_id,
+         N_("SVG id of object to export [optional; defaults to exporting all objects]"), N_("<object id>")},
         {"keep-aspect-ratio", 'a', 0, G_OPTION_ARG_NONE, &keep_aspect_ratio,
          N_("whether to preserve the aspect ratio [optional; defaults to FALSE]"), NULL},
         {"background-color", 'b', 0, G_OPTION_ARG_STRING, &background_color_str,
          N_("set the background color [optional; defaults to None]"), N_("[black, white, #abccee, #aaa...]")},
+        {"unlimited", 'u', 0, G_OPTION_ARG_NONE, &unlimited, N_("Allow huge SVG files"), NULL},
+        {"keep-image-data", 0, 0, G_OPTION_ARG_NONE, &keep_image_data, N_("Keep image data"), NULL},
+        {"no-keep-image-data", 0, 0, G_OPTION_ARG_NONE, &no_keep_image_data, N_("Don't keep image data"), NULL},
         {"version", 'v', 0, G_OPTION_ARG_NONE, &bVersion, N_("show version information"), NULL},
-        {"base-uri", 'b', 0, G_OPTION_ARG_STRING, &base_uri, N_("base uri"), NULL},
         {G_OPTION_REMAINING, 0, 0, G_OPTION_ARG_FILENAME_ARRAY, &args, NULL, N_("[FILE...]")},
         {NULL}
     };
 
-	/* Set the locale so that UTF-8 filenames work */
-	setlocale(LC_ALL, "");
+    /* Set the locale so that UTF-8 filenames work */
+    setlocale(LC_ALL, "");
 
-	g_thread_init(NULL);
+    RSVG_G_TYPE_INIT;
 
     g_option_context = g_option_context_new (_("- SVG Converter"));
     g_option_context_add_main_entries (g_option_context, options_table, NULL);
     g_option_context_set_help_enabled (g_option_context, TRUE);
     if (!g_option_context_parse (g_option_context, &argc, &argv, &error)) {
+        g_option_context_free (g_option_context);
         display_error (error);
         exit (1);
     }
@@ -195,9 +205,12 @@ main (int argc, char **argv)
     if (output != NULL) {
         output_file = fopen (output, "wb");
         if (!output_file) {
-            fprintf (stderr, _("Error saving to file: %s\n"), output);
+            g_printerr (_("Error saving to file: %s\n"), output);
+            g_free (output);
             exit (1);
         }
+
+        g_free (output);
     }
 
     if (args)
@@ -207,50 +220,97 @@ main (int argc, char **argv)
     if (n_args == 0) {
         n_args = 1;
         using_stdin = TRUE;
-    } else if (n_args > 1 && (!format || !(!strcmp (format, "ps") || !strcmp (format, "pdf")))) {
-        fprintf (stderr, _("Multiple SVG files are only allowed for PDF and PS output.\n"));
+    } else if (n_args > 1 && (!format || !(!strcmp (format, "ps") || !strcmp (format, "eps") || !strcmp (format, "pdf")))) {
+        g_printerr (_("Multiple SVG files are only allowed for PDF and (E)PS output.\n"));
         exit (1);
     }
 
+    if (format != NULL &&
+        (g_str_equal (format, "ps") || g_str_equal (format, "eps") || g_str_equal (format, "pdf")) &&
+        !no_keep_image_data)
+        keep_image_data = TRUE;
+
     if (zoom != 1.0)
         x_zoom = y_zoom = zoom;
 
-    rsvg_init ();
     rsvg_set_default_dpi_x_y (dpi_x, dpi_y);
 
+    if (unlimited)
+        flags |= RSVG_HANDLE_FLAG_UNLIMITED;
+
+    if (keep_image_data)
+        flags |= RSVG_HANDLE_FLAG_KEEP_IMAGE_DATA;
+
     for (i = 0; i < n_args; i++) {
+        GFile *file;
+        GInputStream *stream;
+
+        if (using_stdin) {
+            file = NULL;
+#ifdef _WIN32
+            handle = GetStdHandle (STD_INPUT_HANDLE);
+
+            if (handle == INVALID_HANDLE_VALUE) {
+              gchar *emsg = g_win32_error_message (GetLastError());
+              g_printerr ( _("Unable to acquire HANDLE for STDIN: %s\n"), emsg);
+              g_free (emsg);
+              exit (1);
+            }
+            stream = g_win32_input_stream_new (handle, FALSE);
+#else
+            stream = g_unix_input_stream_new (STDIN_FILENO, FALSE);
+#endif
+        } else {
+            file = g_file_new_for_commandline_arg (args[i]);
+            stream = (GInputStream *) g_file_read (file, NULL, &error);
 
-        if (using_stdin)
-            rsvg = rsvg_handle_new_from_stdio_file (stdin, &error);
-        else
-            rsvg = rsvg_handle_new_from_file (args[i], &error);
+            if (stream == NULL)
+                goto done;
+        }
 
-        if (!rsvg) {
-            fprintf (stderr, _("Error reading SVG:"));
+        rsvg = rsvg_handle_new_from_stream_sync (stream, file, flags, NULL, &error);
+
+    done:
+        if (stream) {
+            g_object_unref (stream);
+            stream = NULL;
+        }
+
+        if (file) {
+            g_object_unref (file);
+            file = NULL;
+        }
+
+        if (error != NULL) {
+            g_printerr (_("Error reading SVG:"));
             display_error (error);
-            fprintf (stderr, "\n");
+            g_printerr ("\n");
             exit (1);
         }
 
-        if (base_uri)
-            rsvg_handle_set_base_uri (rsvg, base_uri);
-
-        /* in the case of multi-page output, all subsequent SVGs are scaled to the first's size */
-        rsvg_handle_set_size_callback (rsvg, rsvg_cairo_size_callback, &dimensions, NULL);
+        export_lookup_id = get_lookup_id_from_command_line (export_id);
+        if (export_lookup_id != NULL
+            && !rsvg_handle_has_sub (rsvg, export_lookup_id)) {
+            g_printerr (_("File %s does not have an object with id \"%s\"\n"), args[i], export_id);
+            exit (1);
+        }
 
         if (i == 0) {
             struct RsvgSizeCallbackData size_data;
 
-            rsvg_handle_get_dimensions (rsvg, &dimensions);
+            if (!rsvg_handle_get_dimensions_sub (rsvg, &dimensions, export_lookup_id))
+                g_printerr ("Could not get dimensions for file %s\n", args[i]);
+
+            unscaled_width = dimensions.width;
+            unscaled_height = dimensions.height;
+
             /* if both are unspecified, assume user wants to zoom the image in at least 1 dimension */
             if (width == -1 && height == -1) {
                 size_data.type = RSVG_SIZE_ZOOM;
                 size_data.x_zoom = x_zoom;
                 size_data.y_zoom = y_zoom;
                 size_data.keep_aspect_ratio = keep_aspect_ratio;
-            }
-            /* if both are unspecified, assume user wants to resize image in at least 1 dimension */
-            else if (x_zoom == 1.0 && y_zoom == 1.0) {
+            } else if (x_zoom == 1.0 && y_zoom == 1.0) {
                 /* if one parameter is unspecified, assume user wants to keep the aspect ratio */
                 if (width == -1 || height == -1) {
                     size_data.type = RSVG_SIZE_WH_MAX;
@@ -273,28 +333,45 @@ main (int argc, char **argv)
                 size_data.keep_aspect_ratio = keep_aspect_ratio;
             }
 
-            _rsvg_size_callback (&dimensions.width, &dimensions.height, &size_data);
+            scaled_width = dimensions.width;
+            scaled_height = dimensions.height;
+            _rsvg_size_callback (&scaled_width, &scaled_height, &size_data);
 
             if (!format || !strcmp (format, "png"))
                 surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32,
-                                                      dimensions.width, dimensions.height);
+                                                      scaled_width, scaled_height);
 #ifdef CAIRO_HAS_PDF_SURFACE
             else if (!strcmp (format, "pdf"))
                 surface = cairo_pdf_surface_create_for_stream (rsvg_cairo_write_func, output_file,
-                                                               dimensions.width, dimensions.height);
+                                                               scaled_width, scaled_height);
 #endif
 #ifdef CAIRO_HAS_PS_SURFACE
-            else if (!strcmp (format, "ps"))
+            else if (!strcmp (format, "ps") || !strcmp (format, "eps")){
                 surface = cairo_ps_surface_create_for_stream (rsvg_cairo_write_func, output_file,
-                                                              dimensions.width, dimensions.height);
+                                                              scaled_width, scaled_height);
+                if(!strcmp (format, "eps"))
+                    cairo_ps_surface_set_eps(surface, TRUE);
+            }
 #endif
 #ifdef CAIRO_HAS_SVG_SURFACE
             else if (!strcmp (format, "svg"))
                 surface = cairo_svg_surface_create_for_stream (rsvg_cairo_write_func, output_file,
-                                                               dimensions.width, dimensions.height);
+                                                               scaled_width, scaled_height);
+#endif
+#ifdef CAIRO_HAS_XML_SURFACE
+            else if (!strcmp (format, "xml")) {
+                cairo_device_t *device = cairo_xml_create_for_stream (rsvg_cairo_write_func, output_file);
+                surface = cairo_xml_surface_create (device, CAIRO_CONTENT_COLOR_ALPHA,
+                                                    scaled_width, scaled_height);
+                cairo_device_destroy (device);
+            }
+#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE (1, 10, 0)
+            else if (!strcmp (format, "recording"))
+                surface = cairo_recording_surface_create (CAIRO_CONTENT_COLOR_ALPHA, NULL);
+#endif
 #endif
             else {
-                fprintf (stderr, _("Unknown output format."));
+                g_printerr (_("Unknown output format."));
                 exit (1);
             }
 
@@ -310,26 +387,57 @@ main (int argc, char **argv)
                 ((background_color >> 16) & 0xff) / 255.0, 
                 ((background_color >> 8) & 0xff) / 255.0, 
                 ((background_color >> 0) & 0xff) / 255.0);
-            cairo_rectangle (cr, 0, 0, dimensions.width, dimensions.height);
+            cairo_rectangle (cr, 0, 0, scaled_width, scaled_height);
             cairo_fill (cr);
         }
 
-        rsvg_handle_render_cairo (rsvg, cr);
+        if (export_lookup_id) {
+            RsvgPositionData pos;
+
+            if (!rsvg_handle_get_position_sub (rsvg, &pos, export_lookup_id)) {
+                g_printerr (_("File %s does not have an object with id \"%s\"\n"), args[i], export_id);
+                exit (1);
+            }
+
+            /* Move the whole thing to 0, 0 so the object to export is at the origin */
+            cairo_translate (cr, -pos.x, -pos.y);
+        }
+
+        cairo_scale (cr,
+                     scaled_width / unscaled_width,
+                     scaled_height / unscaled_height);
+        rsvg_handle_render_cairo_sub (rsvg, cr, export_lookup_id);
+
+        g_free (export_lookup_id);
 
         if (!format || !strcmp (format, "png"))
             cairo_surface_write_to_png_stream (surface, rsvg_cairo_write_func, output_file);
-        else
+#if CAIRO_HAS_XML_SURFACE && CAIRO_VERSION >= CAIRO_VERSION_ENCODE (1, 10, 0)
+        else if (!strcmp (format, "recording")) {
+            cairo_device_t *device = cairo_xml_create_for_stream (rsvg_cairo_write_func, output_file);
+            cairo_xml_for_recording_surface (device, surface);
+            cairo_device_destroy (device);
+        }
+#endif
+        else if (!strcmp (format, "xml"))
+          ;
+        else if (!strcmp (format, "svg") || !strcmp (format, "pdf") || !strcmp (format, "ps") || !strcmp (format, "eps"))
             cairo_show_page (cr);
+        else
+          g_assert_not_reached ();
 
-        g_object_unref (G_OBJECT (rsvg));
+        g_object_unref (rsvg);
     }
 
     cairo_destroy (cr);
+
     cairo_surface_destroy (surface);
 
     fclose (output_file);
 
-    rsvg_term ();
+    g_strfreev (args);
+
+    rsvg_cleanup ();
 
     return 0;
 }
